From 284b9500baf0f5038c27510bee9f95a82e1130f2 Mon Sep 17 00:00:00 2001
From: Pavel Kovar <pavel.kovar@nxp.com>
Date: Tue, 21 Nov 2023 16:01:01 +0100
Subject: [PATCH] DHCPv6: Add stateful mode and prefix delegation support
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Overhaul of dhcpv6 client to support IPv6 address autoconfiguration as per
RFC 8415 (stateful DHCPv6 with prefix delegation) and
RFC 3736 (stateless DHCPv6).

Interface:

dhcp6_enable() enables DHCPv6 for a netif. (Originaly dhcp6_enable_stateless)
dhcp6_disable() disable DHCPv6 for a netif (unchanged)
dhcp6_set_client_id_duid() enables use of the app’s own DUID instead of hwaddr.

define LWIP_IPV6_DHCP6_STATEFUL to 1 to support a stateful client.
define LWIP_IPV6_DHCP6_PD to 1 to request a prefix from your router.

Use LWIP_DHCP6_ORO_OPTS_CUSTOM with LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM
to set and proccess additional ORO options.

Limitations and features good to know about:
 - Solicitation is sent only on the router advertisement reception
 - Client always picks the first advertisement and continues with that server.
 - Rapid commit is not supported
 - Client is not keeping a list of multiple potential servers, so rebinding is not supported. The client will transit to the solicitation state instead.
 - When the server replies to renew with address or prefix with zero valid time, the client goes to the solicitation state.

When enabled, requests are only issued after the receipt of RA with the corresponding bits (M/O) set.

Signed-off-by: Pavel Kovar <pavel.kovar@nxp.com>
---
 src/core/ipv6/dhcp6.c         | 1743 +++++++++++++++++++++++++--------
 src/include/lwip/dhcp6.h      |   61 +-
 src/include/lwip/prot/dhcp6.h |  121 ++-
 test/unit/Filelists.cmake     |    1 +
 test/unit/Filelists.mk        |    1 +
 test/unit/dhcp6/test_dhcp6.c  | 1536 +++++++++++++++++++++++++++++
 test/unit/dhcp6/test_dhcp6.h  |   36 +
 test/unit/lwip_unittests.c    |    2 +
 test/unit/lwipopts.h          |    5 +
 9 files changed, 3089 insertions(+), 417 deletions(-)
 create mode 100644 test/unit/dhcp6/test_dhcp6.c
 create mode 100644 test/unit/dhcp6/test_dhcp6.h

diff --git a/src/core/ipv6/dhcp6.c b/src/core/ipv6/dhcp6.c
index e6a7e64d..fbf7621b 100644
--- a/src/core/ipv6/dhcp6.c
+++ b/src/core/ipv6/dhcp6.c
@@ -4,28 +4,31 @@
  * @defgroup dhcp6 DHCPv6
  * @ingroup ip6
  * DHCPv6 client: IPv6 address autoconfiguration as per
- * RFC 3315 (stateful DHCPv6) and
+ * RFC 8415 (stateful DHCPv6 with prefix delegation) and
  * RFC 3736 (stateless DHCPv6).
  *
- * For now, only stateless DHCPv6 is implemented!
+ * Limitations and features you should know about:
+ *  - Solicitation is sent only on router advertisement reception
+ *  - Client always picks first advertisement and continues with that server.
+ *  - Rapid commit is not supported
+ *  - Client is not keeping list of multiple potential servers so rebinding is
+ *    not supported. Client will transit to solicitation state instead.
+ *  - When server replies to renew with address or prefix with zero valid time
+ *    client goes to solicitation state.
  *
- * TODO:
- * - enable/disable API to not always start when RA is received
- * - stateful DHCPv6 (for now, only stateless DHCPv6 for DNS and NTP servers works)
- * - create Client Identifier?
- * - only start requests if a valid local address is available on the netif
- * - only start information requests if required (not for every RA)
- *
- * dhcp6_enable_stateful() enables stateful DHCPv6 for a netif (stateless disabled)<br>
- * dhcp6_enable_stateless() enables stateless DHCPv6 for a netif (stateful disabled)<br>
+ * dhcp6_enable() enables DHCPv6 for a netif <br>
  * dhcp6_disable() disable DHCPv6 for a netif
  *
+ * define LWIP_IPV6_DHCP6_STATEFUL to 1 to support stateful client (Can give you an address using DHCP6)
+ * define LWIP_IPV6_DHCP6_PD to 1 to request prefix form your router.
+ *
  * When enabled, requests are only issued after receipt of RA with the
  * corresponding bits set.
  */
 
 /*
  * Copyright (c) 2018 Simon Goldschmidt
+ * Copyright 2023 NXP
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without modification,
@@ -61,22 +64,31 @@
 
 #include "lwip/dhcp6.h"
 #include "lwip/prot/dhcp6.h"
+#include "lwip/prot/iana.h"
 #include "lwip/def.h"
 #include "lwip/udp.h"
 #include "lwip/dns.h"
 
 #include <string.h>
+#include <lwip/dhcp.h>
+#include <lwip/sys.h>
 
 #ifdef LWIP_HOOK_FILENAME
 #include LWIP_HOOK_FILENAME
 #endif
-#ifndef LWIP_HOOK_DHCP6_APPEND_OPTIONS
-#define LWIP_HOOK_DHCP6_APPEND_OPTIONS(netif, dhcp6, state, msg, msg_type, options_len_ptr, max_len)
+
+#if defined(LWIP_DHCP6_ORO_OPTS_CUSTOM) && !defined(LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM)
+#warning "Custom option set in LWIP_DHCP6_ORO_OPTS_CUSTOM but missing definition of LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM to parse it"
+#endif
+#if !defined(LWIP_DHCP6_ORO_OPTS_CUSTOM) && defined(LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM)
+#warning "LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM to parse registered to parse custom option but no option set in LWIP_DHCP6_ORO_OPTS_CUSTOM"
 #endif
-#ifndef LWIP_HOOK_DHCP6_PARSE_OPTION
-#define LWIP_HOOK_DHCP6_PARSE_OPTION(netif, dhcp6, state, msg, msg_type, option, len, pbuf, offset) do { LWIP_UNUSED_ARG(msg); } while(0)
+
+#ifdef LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM
+extern void LWIP_HOOK_DHCP6_PARSE_ORO_OPTS_CUSTOM(const struct netif * netif, u16_t type, u8_t state, const struct pbuf * p, u16_t offset, u16_t opt_len);
 #endif
 
+
 #if LWIP_DNS && LWIP_DHCP6_MAX_DNS_SERVERS
 #if DNS_MAX_SERVERS > LWIP_DHCP6_MAX_DNS_SERVERS
 #define LWIP_DHCP6_PROVIDE_DNS_SERVERS LWIP_DHCP6_MAX_DNS_SERVERS
@@ -87,42 +99,7 @@
 #define LWIP_DHCP6_PROVIDE_DNS_SERVERS 0
 #endif
 
-
-/** Option handling: options are parsed in dhcp6_parse_reply
- * and saved in an array where other functions can load them from.
- * This might be moved into the struct dhcp6 (not necessarily since
- * lwIP is single-threaded and the array is only used while in recv
- * callback). */
-enum dhcp6_option_idx {
-  DHCP6_OPTION_IDX_CLI_ID = 0,
-  DHCP6_OPTION_IDX_SERVER_ID,
-#if LWIP_DHCP6_PROVIDE_DNS_SERVERS
-  DHCP6_OPTION_IDX_DNS_SERVER,
-  DHCP6_OPTION_IDX_DOMAIN_LIST,
-#endif /* LWIP_DHCP_PROVIDE_DNS_SERVERS */
-#if LWIP_DHCP6_GET_NTP_SRV
-  DHCP6_OPTION_IDX_NTP_SERVER,
-#endif /* LWIP_DHCP_GET_NTP_SRV */
-  DHCP6_OPTION_IDX_MAX
-};
-
-struct dhcp6_option_info {
-  u8_t option_given;
-  u16_t val_start;
-  u16_t val_length;
-};
-
-/** Holds the decoded option info, only valid while in dhcp6_recv. */
-struct dhcp6_option_info dhcp6_rx_options[DHCP6_OPTION_IDX_MAX];
-
-#define dhcp6_option_given(dhcp6, idx)           (dhcp6_rx_options[idx].option_given != 0)
-#define dhcp6_got_option(dhcp6, idx)             (dhcp6_rx_options[idx].option_given = 1)
-#define dhcp6_clear_option(dhcp6, idx)           (dhcp6_rx_options[idx].option_given = 0)
-#define dhcp6_clear_all_options(dhcp6)           (memset(dhcp6_rx_options, 0, sizeof(dhcp6_rx_options)))
-#define dhcp6_get_option_start(dhcp6, idx)       (dhcp6_rx_options[idx].val_start)
-#define dhcp6_get_option_length(dhcp6, idx)      (dhcp6_rx_options[idx].val_length)
-#define dhcp6_set_option(dhcp6, idx, start, len) do { dhcp6_rx_options[idx].val_start = (start); dhcp6_rx_options[idx].val_length = (len); }while(0)
-
+#define dhcp6_sec_to_ticks(sec) ((sec*1000)/DHCP6_TIMER_MSECS)
 
 const ip_addr_t dhcp6_All_DHCP6_Relay_Agents_and_Servers = IPADDR6_INIT_HOST(0xFF020000, 0, 0, 0x00010002);
 const ip_addr_t dhcp6_All_DHCP6_Servers = IPADDR6_INIT_HOST(0xFF020000, 0, 0, 0x00010003);
@@ -130,9 +107,30 @@ const ip_addr_t dhcp6_All_DHCP6_Servers = IPADDR6_INIT_HOST(0xFF020000, 0, 0, 0x
 static struct udp_pcb *dhcp6_pcb;
 static u8_t dhcp6_pcb_refcount;
 
+static const u16_t requested_options[] = {
+#if LWIP_DHCP6_PROVIDE_DNS_SERVERS
+    DHCP6_OPTION_DNS_SERVERS,
+#endif
+#if LWIP_DHCP6_GET_NTP_SRV
+    DHCP6_OPTION_SNTP_SERVERS,
+#endif
+#ifdef LWIP_DHCP6_ORO_OPTS_CUSTOM
+  LWIP_DHCP6_ORO_OPTS_CUSTOM,
+#endif
+    0U /* end of list */
+};
+
 
-/* receive, unfold, parse and free incoming messages */
 static void dhcp6_recv(void *arg, struct udp_pcb *pcb, struct pbuf *p, const ip_addr_t *addr, u16_t port);
+static void dhcp6_information_request(struct netif *netif, struct dhcp6 *dhcp6);
+#if LWIP_IPV6_DHCP6_STATEFUL
+static void dhcp6_solicitation(struct netif *netif, struct dhcp6 *dhcp6);
+static void dhcp6_request(struct netif *netif, struct dhcp6 *dhcp6);
+static void dhcp6_renew(struct netif *netif, struct dhcp6 *dhcp6);
+static void dhcp6_rebind(struct netif *netif, struct dhcp6 *dhcp6);
+static void dhcp6_release(struct netif *netif, struct dhcp6 *dhcp6);
+static void set_addr_not_advertised(struct dhcp6 *dhcp6);
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
 
 /** Ensure DHCP PCB is allocated and bound */
 static err_t
@@ -190,29 +188,12 @@ dhcp6_set_struct(struct netif *netif, struct dhcp6 *dhcp6)
 
   /* clear data structure */
   memset(dhcp6, 0, sizeof(struct dhcp6));
-  /* dhcp6_set_state(&dhcp, DHCP6_STATE_OFF); */
+#if LWIP_IPV6_DHCP6_STATEFUL
+  dhcp6->addr_idx = -1;
+#endif
   netif_set_client_data(netif, LWIP_NETIF_CLIENT_DATA_INDEX_DHCP6, dhcp6);
 }
 
-/**
- * @ingroup dhcp6
- * Removes a struct dhcp6 from a netif.
- *
- * ATTENTION: Only use this when not using dhcp6_set_struct() to allocate the
- *            struct dhcp6 since the memory is passed back to the heap.
- *
- * @param netif the netif from which to remove the struct dhcp
- */
-void dhcp6_cleanup(struct netif *netif)
-{
-  LWIP_ASSERT("netif != NULL", netif != NULL);
-
-  if (netif_dhcp6_data(netif) != NULL) {
-    mem_free(netif_dhcp6_data(netif));
-    netif_set_client_data(netif, LWIP_NETIF_CLIENT_DATA_INDEX_DHCP6, NULL);
-  }
-}
-
 static struct dhcp6*
 dhcp6_get_struct(struct netif *netif, const char *dbg_requester)
 {
@@ -221,17 +202,20 @@ dhcp6_get_struct(struct netif *netif, const char *dbg_requester)
     LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("%s: mallocing new DHCPv6 client\n", dbg_requester));
     dhcp6 = (struct dhcp6 *)mem_malloc(sizeof(struct dhcp6));
     if (dhcp6 == NULL) {
-      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("%s: could not allocate dhcp6\n", dbg_requester));
+      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_SERIOUS,
+                  ("%s: could not allocate dhcp6\n", dbg_requester));
       return NULL;
     }
-
     /* clear data structure, this implies DHCP6_STATE_OFF */
     memset(dhcp6, 0, sizeof(struct dhcp6));
+#if LWIP_IPV6_DHCP6_STATEFUL
+    dhcp6->addr_idx = -1;
+#endif
     /* store this dhcp6 client in the netif */
     netif_set_client_data(netif, LWIP_NETIF_CLIENT_DATA_INDEX_DHCP6, dhcp6);
   } else {
     /* already has DHCP6 client attached */
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("%s: using existing DHCPv6 client\n", dbg_requester));
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("%s: using existing DHCPv6 client\n", dbg_requester));
   }
 
   if (!dhcp6->pcb_allocated) {
@@ -240,128 +224,296 @@ dhcp6_get_struct(struct netif *netif, const char *dbg_requester)
       netif_set_client_data(netif, LWIP_NETIF_CLIENT_DATA_INDEX_DHCP6, NULL);
       return NULL;
     }
-    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("%s: allocated dhcp6\n", dbg_requester));
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("%s: dhcp6 successfully allocated\n", dbg_requester));
     dhcp6->pcb_allocated = 1;
   }
   return dhcp6;
 }
 
+static void
+dhcp6_free_struct(struct netif *netif, const char *dbg_requester) {
+  struct dhcp6 *dhcp6 = netif_dhcp6_data(netif);
+  if (dhcp6 == NULL) {
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("%s: DHCPv6 client already freed\n", dbg_requester));
+  } else {
+#if LWIP_IPV6_DHCP6_STATEFUL
+    if(dhcp6->server_id != NULL) {
+      mem_free(dhcp6->server_id);
+    }
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+    mem_free(dhcp6);
+    netif_set_client_data(netif, LWIP_NETIF_CLIENT_DATA_INDEX_DHCP6, NULL);
+    dhcp6_dec_pcb_refcount();
+  }
+}
+
 /*
  * Set the DHCPv6 state
- * If the state changed, reset the number of tries.
+ * If the state changed, reset the number of tries and set retransmission params
+ * according RFC.
  */
 static void
-dhcp6_set_state(struct dhcp6 *dhcp6, u8_t new_state, const char *dbg_caller)
+dhcp6_set_state(struct netif *netif, struct dhcp6 *dhcp6, u8_t new_state, const char *dbg_caller)
 {
-  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("DHCPv6 state: %d -> %d (%s)\n",
+  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_set_state: %d -> %d (caller: %s)\n",
     dhcp6->state, new_state, dbg_caller));
   if (new_state != dhcp6->state) {
     dhcp6->state = new_state;
     dhcp6->tries = 0;
     dhcp6->request_timeout = 0;
-  }
-}
+#if LWIP_IPV6_DHCP6_STATEFUL
+    dhcp6->max_request_timeout = 0;
+    dhcp6->max_retrans_cnt = 0;
+    dhcp6->max_retrans_dur = 0;
+#endif
 
-static int
-dhcp6_stateless_enabled(struct dhcp6 *dhcp6)
-{
-  if ((dhcp6->state == DHCP6_STATE_STATELESS_IDLE) ||
-      (dhcp6->state == DHCP6_STATE_REQUESTING_CONFIG)) {
-    return 1;
-  }
-  return 0;
-}
+    switch (dhcp6->state) {
 
-/*static int
-dhcp6_stateful_enabled(struct dhcp6 *dhcp6)
-{
-  if (dhcp6->state == DHCP6_STATE_OFF) {
-    return 0;
-  }
-  if (dhcp6_stateless_enabled(dhcp6)) {
-    return 0;
-  }
-  return 1;
-}*/
+      case DHCP6_STATE_OFF:
+        dhcp6_free_struct(netif, dbg_caller);
+        /* dhcp6 struct doesn't exist here anymore. */
+        return;
 
-/**
- * @ingroup dhcp6
- * Enable stateful DHCPv6 on this netif
- * Requests are sent on receipt of an RA message with the
- * ND6_RA_FLAG_MANAGED_ADDR_CONFIG flag set.
- *
- * A struct dhcp6 will be allocated for this netif if not
- * set via @ref dhcp6_set_struct before.
- *
- * @todo: stateful DHCPv6 not supported, yet
- */
-err_t
-dhcp6_enable_stateful(struct netif *netif)
-{
-  LWIP_UNUSED_ARG(netif);
-  LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("stateful dhcp6 not implemented yet\n"));
-  return ERR_VAL;
+      case DHCP6_STATE_IDLE:
+        break;
+
+      case DHCP6_STATE_SL_REQUESTING_CONFIG:
+        dhcp6_information_request(netif, dhcp6);
+        dhcp6->request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_INF_TIMEOUT);
+        dhcp6->max_request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_INF_MAX_RT);
+        break;
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+      case DHCP6_STATE_SF_INIT_DELAY:
+        /* something random between 0 and SOL_MAX delay Fixme: randomize*/
+        dhcp6->request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_SOL_MAX_DELAY)/2;
+        break;
+
+      case DHCP6_STATE_SF_SOLICITING:
+        /* Set initial IA NA T1 and T2 preference to no preference */
+        set_addr_not_advertised(dhcp6);
+        dhcp6->addr_t1 = 0;
+        dhcp6->addr_t2 = 0;
+        dhcp6_solicitation(netif, dhcp6);
+        dhcp6->request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_SOL_TIMEOUT);
+        dhcp6->max_request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_SOL_MAX_RT);
+        break;
+
+      case DHCP6_STATE_SF_REQUESTING:
+        dhcp6_request(netif, dhcp6);
+        dhcp6->request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_REQ_TIMEOUT);
+        dhcp6->max_request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_REQ_MAX_RT);
+        dhcp6->max_retrans_cnt = DHCP6_PAR_REQ_MAX_RC;
+        break;
+
+      case DHCP6_STATE_SF_BOUND:
+        dhcp6->request_timeout = 0;
+        break;
+
+      case DHCP6_STATE_SF_RENEWING:
+          dhcp6_renew(netif, dhcp6);
+          dhcp6->request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_REN_TIMEOUT);
+          dhcp6->max_request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_REN_MAX_RT);
+          break;
+
+      case DHCP6_STATE_SF_REBINDING:
+          dhcp6_rebind(netif, dhcp6);
+          dhcp6->request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_REB_TIMEOUT);
+          dhcp6->max_request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_REB_MAX_RT);
+          break;
+
+      case DHCP6_STATE_SF_RELEASING:
+          dhcp6_release(netif, dhcp6);
+          dhcp6->request_timeout = dhcp6_sec_to_ticks(DHCP6_PAR_REL_TIMEOUT);
+          dhcp6->max_retrans_cnt = DHCP6_PAR_REL_MAX_RC;
+          break;
+
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+      default:
+          LWIP_ASSERT("Unhandled state at dhcp6_set_state", 0);
+    } /* switch */
+    dhcp6->request_timeout_cntr = dhcp6->request_timeout;
+    LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_set_state: setting request timeout to %"U16_F" ms\n",
+                                                dhcp6->request_timeout * DHCP6_TIMER_MSECS));
+  } /* if state changed */
 }
 
 /**
  * @ingroup dhcp6
- * Enable stateless DHCPv6 on this netif
- * Requests are sent on receipt of an RA message with the
- * ND6_RA_FLAG_OTHER_CONFIG flag set.
+ * Enable DHCPv6 on this netif
+ * Requests are sent on receipt of an RA message.
  *
  * A struct dhcp6 will be allocated for this netif if not
  * set via @ref dhcp6_set_struct before.
  */
 err_t
-dhcp6_enable_stateless(struct netif *netif)
+dhcp6_enable(struct netif *netif)
 {
   struct dhcp6 *dhcp6;
 
-  LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_enable_stateless(netif=%p) %c%c%"U16_F"\n", (void *)netif, netif->name[0], netif->name[1], (u16_t)netif->num));
+  LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_enable_stateful(netif=%p) %c%c%"U16_F"\n",
+              (void *)netif, netif->name[0], netif->name[1], (u16_t)netif->num));
+  LWIP_ASSERT_CORE_LOCKED();
 
-  dhcp6 = dhcp6_get_struct(netif, "dhcp6_enable_stateless()");
+  dhcp6 = dhcp6_get_struct(netif, "dhcp6_enable_stateful");
   if (dhcp6 == NULL) {
     return ERR_MEM;
   }
-  if (dhcp6_stateless_enabled(dhcp6)) {
-    LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE, ("dhcp6_enable_stateless(): stateless DHCPv6 already enabled\n"));
-    return ERR_OK;
-  } else if (dhcp6->state != DHCP6_STATE_OFF) {
-    /* stateful running */
-    /* @todo: stop stateful once it is implemented */
-    LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE, ("dhcp6_enable_stateless(): switching from stateful to stateless DHCPv6\n"));
+  if (dhcp6->state == DHCP6_STATE_OFF) {
+    LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE, ("dhcp6_enable: DHCPv6 enabled\n"));
+    dhcp6_set_state(netif, dhcp6, DHCP6_STATE_IDLE, "dhcp6_enable");
+  } else if (dhcp6->state == DHCP6_STATE_OFF) {
+    LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE, ("dhcp6_enable: DHCPv6 is in releasing process. Be enabled when done.\n"));
+    dhcp6->state_after_release = DHCP6_STATE_IDLE;
+    return ERR_INPROGRESS;
+  } else {
+    LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE, ("dhcp6_enable: DHCPv6 is not disabled\n"));
+    return ERR_ALREADY;
   }
-  LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE, ("dhcp6_enable_stateless(): stateless DHCPv6 enabled\n"));
-  dhcp6_set_state(dhcp6, DHCP6_STATE_STATELESS_IDLE, "dhcp6_enable_stateless");
+
   return ERR_OK;
 }
 
 /**
  * @ingroup dhcp6
- * Disable stateful or stateless DHCPv6 on this netif
- * Requests are sent on receipt of an RA message with the
- * ND6_RA_FLAG_OTHER_CONFIG flag set.
+ * Disable DHCPv6 on specified netif and dealocates it't memory.
  */
 void
 dhcp6_disable(struct netif *netif)
 {
   struct dhcp6 *dhcp6;
 
-  LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_disable(netif=%p) %c%c%"U16_F"\n", (void *)netif, netif->name[0], netif->name[1], (u16_t)netif->num));
+  LWIP_DEBUGF(DHCP_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_STATE, ("dhcp6_disable(netif=%p) %c%c%"U16_F"\n",
+              (void *)netif, netif->name[0], netif->name[1], (u16_t)netif->num));
 
   dhcp6 = netif_dhcp6_data(netif);
   if (dhcp6 != NULL) {
-    if (dhcp6->state != DHCP6_STATE_OFF) {
-      LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE, ("dhcp6_disable(): DHCPv6 disabled (old state: %s)\n",
-        (dhcp6_stateless_enabled(dhcp6) ? "stateless" : "stateful")));
-      dhcp6_set_state(dhcp6, DHCP6_STATE_OFF, "dhcp6_disable");
-      if (dhcp6->pcb_allocated != 0) {
-        dhcp6_dec_pcb_refcount(); /* free DHCPv6 PCB if not needed any more */
-        dhcp6->pcb_allocated = 0;
-      }
+    switch (dhcp6->state) {
+      case DHCP6_STATE_OFF:
+          break;
+      case DHCP6_STATE_IDLE:
+      case DHCP6_STATE_SL_REQUESTING_CONFIG:
+#if LWIP_IPV6_DHCP6_STATEFUL
+      case DHCP6_STATE_SF_INIT_DELAY:
+      case DHCP6_STATE_SF_SOLICITING:
+      case DHCP6_STATE_SF_REQUESTING:
+#endif
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_OFF, "disable");
+          break;
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+      case DHCP6_STATE_SF_BOUND:
+      case DHCP6_STATE_SF_RENEWING:
+      case DHCP6_STATE_SF_REBINDING:
+          dhcp6_set_state(netif, dhcp6, DHCP6_STATE_SF_RELEASING, "disable");
+          break;
+
+      case DHCP6_STATE_SF_RELEASING:
+          break;
+
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+      default:
+          LWIP_ASSERT("Unhandled state at dhcp6_set_state", 0);
     }
+    dhcp6->state_after_release = DHCP6_STATE_OFF;
+  }
+}
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+/**
+ * Allows you to set a reference to custom DUID of client identifier.
+ *
+ * DUID format is described in RFC 8415 section 11.
+ *
+ * By default lwIP will send DUID Based on Link-Layer Address (DUID-LL).
+ *
+ * @param netif
+ * @param duid      Ptr to DUID data or NULL to set default DUID mentioned above.
+ * @param duid_len  Length of DUID
+ */
+void dhcp6_set_client_id_duid(struct netif *netif, const void *duid, u16_t duid_len)
+{
+  struct dhcp6 *dhcp6;
+  LWIP_ASSERT("netif is NULL", netif != NULL);
+  LWIP_ASSERT_CORE_LOCKED();
+  dhcp6 = netif_dhcp6_data(netif);
+  LWIP_ASSERT("Enable dhcp6 first", dhcp6 != NULL);
+  LWIP_ASSERT("Duid must be null or longer than 0", ( (duid != NULL) && (duid_len > 0) ) || (duid == NULL) );
+  if (dhcp6 != NULL) {
+    dhcp6->cli_id_usr_duid = duid;
+    dhcp6->cli_id_usr_duid_len = duid_len;
+  }
+}
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
+
+#if LWIP_IPV6_DHCP6_PD
+/**
+ * Register function which will be called on change of delegated prefix.
+ * @param netif
+ * @param callback function
+ */
+void
+dhcp6_register_pd_callback(struct netif *netif, dhcp6_pd_callback_fn callback)
+{
+  struct dhcp6 *dhcp6;
+  LWIP_ASSERT("netif is NULL", netif != NULL);
+  LWIP_ASSERT_CORE_LOCKED();
+  dhcp6 = netif_dhcp6_data(netif);
+  LWIP_ASSERT("Enable dhcp6 first", dhcp6 != NULL);
+  if (dhcp6 != NULL) {
+    dhcp6->pd_callback = callback;
+  }
+}
+
+/**
+ * Register function which will be called on change of delegated prefix.
+ * @param netif
+ * @returns pointer to internal @ref struct dhcp6_delegated_prefix or NULL if client is disabled.
+ *
+ */
+const struct dhcp6_delegated_prefix *
+dhcp6_get_delegated_prefix(struct netif *netif)
+{
+  struct dhcp6 *dhcp6;
+  LWIP_ASSERT("netif is NULL", netif != NULL);
+  LWIP_ASSERT_CORE_LOCKED();
+  dhcp6 = netif_dhcp6_data(netif);
+
+  if (dhcp6 != NULL) {
+    return &dhcp6->prefix;
   }
+  return NULL;
+}
+
+/* Return true if we have the prefix stored by dhcp6_parse_ia_pd. Doesn't checks valid time.*/
+static u8_t
+is_prefix_advertised(const struct dhcp6 *dhcp6)
+{
+  return (dhcp6->prefix.prefix_len > 0);
+}
+
+/* Sets prefix to be "not delegated". is_prefix_advertised() will return false.*/
+static void
+set_prefix_not_delegated(struct dhcp6 *dhcp6)
+{
+  dhcp6->prefix.prefix_len = 0U;
+}
+#endif /* LWIP_IPV6_DHCP6_PD */
+
+#if LWIP_IPV6_DHCP6_STATEFUL
+static u8_t
+is_addr_advertised(const struct dhcp6 *dhcp6)
+{
+  return !(ip6_addr_isany(&dhcp6->addr));
+}
+
+/* Sets address to be "not advertised". is_addr_advertised() will then return false. */
+static void
+set_addr_not_advertised(struct dhcp6 *dhcp6)
+{
+  ip6_addr_set_any(&dhcp6->addr);
 }
+#endif /* LWIP_IPV6_DHCP6_STATEFUL */
 
 /**
  * Create a DHCPv6 request, fill in common headers
@@ -385,20 +537,22 @@ dhcp6_create_msg(struct netif *netif, struct dhcp6 *dhcp6, u8_t message_type,
   p_out = pbuf_alloc(PBUF_TRANSPORT, sizeof(struct dhcp6_msg) + opt_len_alloc, PBUF_RAM);
   if (p_out == NULL) {
     LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE | LWIP_DBG_LEVEL_SERIOUS,
-                ("dhcp6_create_msg(): could not allocate pbuf\n"));
+                ("dhcp6_create_msg: could not allocate pbuf\n"));
     return NULL;
   }
   LWIP_ASSERT("dhcp6_create_msg: check that first pbuf can hold struct dhcp6_msg",
               (p_out->len >= sizeof(struct dhcp6_msg) + opt_len_alloc));
-
-  /* @todo: limit new xid for certain message types? */
+  
   /* reuse transaction identifier in retransmissions */
   if (dhcp6->tries == 0) {
     dhcp6->xid = LWIP_RAND() & 0xFFFFFF;
+#if LWIP_IPV6_DHCP6_STATEFUL
+    dhcp6->trans_started_at = sys_now();
+#endif
   }
 
   LWIP_DEBUGF(DHCP6_DEBUG | LWIP_DBG_TRACE,
-              ("transaction id xid(%"X32_F")\n", dhcp6->xid));
+              (" transaction id xid(%"X32_F")\n", dhcp6->xid));
 
   msg_out = (struct dhcp6_msg *)p_out->payload;
   memset(msg_out, 0, sizeof(struct dhcp6_msg) + opt_len_alloc);
@@ -408,9 +562,19 @@ dhcp6_create_msg(struct netif *netif, struct dhcp6 *dhcp6, u8_t message_type,
   msg_out->transaction_id[1] = (u8_t)(dhcp6->xid >> 8);
   msg_out->transaction_id[2] = (u8_t)dhcp6->xid;
   *options_out_len = 0;
+
   return p_out;
 }
 
+#if LWIP_IPV6_DHCP6_PD
+static u16_t
+dhcp6_option_byte(u16_t options_out_len, u8_t *options, u8_t value)
+{
+  options[options_out_len++] = value;
+  return options_out_len;
+}
+#endif /* LWIP_IPV6_DHCP6_PD */
+
 static u16_t
 dhcp6_option_short(u16_t options_out_len, u8_t *options, u16_t value)
 {
